part of viltage;

class Entity extends Sprite {
  int layer;
  Display display;
  List<State> states = new List<State>();
  State state;
  int activeState = 0;
  int posX, posY;
  bool useBoxPos = true;
  
  Entity(this.layer, this.posX, this.posY, parentScreen) : super() {
    if(parentScreen is Display) this.display = parentScreen;
    else if(parentScreen is VilTAGE) this.display = parentScreen.screen;
    else if(parentScreen is Entity) this.display = parentScreen.display;
    
    display.entities[layer].add(this);
    
    states.add(new State(this));
    state = states[activeState];
  }
  
  update(num fps) {
    removeChildren();
    addChild(getSprite(display.viltage));
    state = states[activeState];
    if(useBoxPos) {
      x = posX * display.viltage.config.boxWidth;
      y = posY * display.viltage.config.boxHeight;
    }
  }
  
  remove() {
    display.entities[layer].remove(this);
  }
  
  Sprite getSprite(VilTAGE viltage) {
    Sprite s = new Sprite();
    for(int i = 0; i < states[activeState].nodes.length; i++) {
      s.addChild(states[activeState].nodes[i].getField(viltage));
    }
    return s;
  }
  
  CharNode createCharNode(int x, int y, String text) => states[activeState].createCharNode(x, y, text);
  List<CharNode> createCharNodeLine(int x, int y, String text, [bool horizontal=true]) => states[activeState].createCharNodeLine(x, y, text, horizontal);
  List<List<CharNode>> createCharNodeRect(int x, int y, List<String> text) => states[activeState].createCharNodeRect(x, y, text);
}