part of viltage;

class Input {
  List<bool> _keys = new List<bool>();
  List<bool> _pressedKeys = new List<bool>();
  List<bool> _previousKeys = new List<bool>();
  
  Input() {
    for(int i = 0; i < 256; i++) {
      _keys.add(false);
      _pressedKeys.add(false);
      _previousKeys.add(false);
    }
    
    window.onKeyDown.listen((HTML.KeyboardEvent e) {
      _keys[e.keyCode]=true;
      e.preventDefault();
    });

    window.onKeyUp.listen((HTML.KeyboardEvent e) {
      _keys[e.keyCode]=false;
      e.preventDefault();
    });
  }

  bool isHeld(int keyCode) => _keys[keyCode];
  bool isPressed(int keyCode) => _pressedKeys[keyCode];
  
  update() {
    for(int i = 0; i < 256; i++) {
      _pressedKeys[i] = _keys[i] && !_previousKeys[i];
      
      _previousKeys[i] = _keys[i];
    }
  }
}